## Update a model access policy

### cURL

```
curl --request PUT \
  --url https://app.barndoor.ai/api/llm-gateway/admin/model-access/{id} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "<string>",
  "scope_type": "<string>",
  "scope_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "scope_value": "<string>",
  "targets": [
    {
      "kind": "model_alias",
      "alias": "gpt-4o-mini"
    }
  ],
  "enabled": true
}
'  
```

### Python

```
import requests

url = "https://app.barndoor.ai/api/llm-gateway/admin/model-access/{id}"

payload = {
    "name": "<string>",
    "scope_type": "<string>",
    "scope_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "scope_value": "<string>",
    "targets": [
        {
            "kind": "model_alias",
            "alias": "gpt-4o-mini"
        }
    ],
    "enabled": True
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch API)

```
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    name: '<string>',
    scope_type: '<string>',
    scope_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
    scope_value: '<string>',
    targets: [{kind: 'model_alias', alias: 'gpt-4o-mini'}],
    enabled: true
  })
};

fetch('https://app.barndoor.ai/api/llm-gateway/admin/model-access/{id}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://app.barndoor.ai/api/llm-gateway/admin/model-access/{id}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS => json_encode([
    'name' => '<string>',
    'scope_type' => '<string>',
    'scope_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
    'scope_value' => '<string>',
    'targets' => [
        [
            'kind' => 'model_alias',
            'alias' => 'gpt-4o-mini'
        ]
    ],
    'enabled' => true
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>
```

### Go

```
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://app.barndoor.ai/api/llm-gateway/admin/model-access/{id}"

payload := strings.NewReader("{\n  \"name\": \"<string>\",\n  \"scope_type\": \"<string>\",\n  \"scope_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"scope_value\": \"<string>\",\n  \"targets\": [\n    {\n      \"kind\": \"model_alias\",\n      \"alias\": \"gpt-4o-mini\"\n    }\n  ],\n  \"enabled\": true\}")

req, _ := http.NewRequest("PUT", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Java (Unirest)

```
HttpResponse<String> response = Unirest.put("https://app.barndoor.ai/api/llm-gateway/admin/model-access/{id}")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"<string>\",\n  \"scope_type\": \"<string>\",\n  \"scope_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"scope_value\": \"<string>\",\n  \"targets\": [\n    {\n      \"kind\": \"model_alias\",\n      \"alias\": \"gpt-4o-mini\"\n    }\n  ],\n  \"enabled\": true\}")
  .asString();
```

### Ruby

```
require 'uri'
require 'net/http'

url = URI("https://app.barndoor.ai/api/llm-gateway/admin/model-access/{id}")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"<string>\",\n  \"scope_type\": \"<string>\",\n  \"scope_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"scope_value\": \"<string>\",\n  \"targets\": [\n    {\n      \"kind\": \"model_alias\",\n      \"alias\": \"gpt-4o-mini\"\n    }\n  ],\n  \"enabled\": true\}"

response = http.request(request)
puts response.read_body
```

### Response Codes

- 200: Success
- 400: Bad Request
- 404: Not Found

### Successful Response Example

```
{
  "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "org_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "name": "<string>",
  "targets": [
    {
      "kind": "model_alias",
      "alias": "gpt-4o-mini"
    }
  ],
  "enabled": true,
  "scope_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "scope_value": "<string>"
}
```

### Error Response Example

```
{
  "error": "BadRequest",
  "message": "request_timeout_secs must be between 1 and 3600"
}
```
